#include <string.h>
#include "global.h"
#include "patchlev.h"

CONFIG driver_config;
DRV_LIST driver = {MAGIC, do_get_dftab, do_ETM_exec, &driver_config};

static int16 do_dummy1(void) { return do_dummy(1); }
static int16 do_dummy2(void) { return do_dummy(2); }
static int16 do_dummy3(void) { return do_dummy(3); }
static int16 do_dummy4(void) { return do_dummy(4); }
static int16 do_dummy5(void) { return do_dummy(5); }
static int16 do_dummy6(void) { return do_dummy(6); }
static int16 do_dummy7(void) { return do_dummy(7); }
static int16 do_dummy8(void) { return do_dummy(8); }

TPL trampoline = {
  TRANSPORT_DRIVER,
  "Scott Bigham (GlueSTiK\277 v" GS_VERSION ")",
  "01.11",
  do_KRmalloc,
  do_KRfree,
  do_KRgetfree,
  do_KRrealloc,
  do_get_err_text,
  do_getvstr,
  do_carrier_detect,
  do_TCP_open,
  do_TCP_close,
  do_TCP_send,
  do_TCP_wait_state,
  do_TCP_ack_wait,
  do_UDP_open,
  do_UDP_close,
  do_UDP_send,
  do_CNkick,
  do_CNbyte_count,
  do_CNget_char,
  do_CNget_NDB,
  do_CNget_block,
  do_housekeep,
  do_resolve,
  do_ser_disable,
  do_ser_enable,
  do_set_flag,
  do_clear_flag,
  do_CNgetinfo,
  do_on_port,
  do_off_port,
  do_setvstr,
  do_query_port,
  do_resolve,		/* g_resolve() == resolve() */
  do_TCP_wait_state,	/* g_TCP_wait_state() == TCP_wait_state() */
  do_dummy1,		/* These are to catch functions from new STiK */
  do_dummy2,		/*   versions... */
  do_dummy3,
  do_dummy4,
  do_dummy5,
  do_dummy6,
  do_dummy7,
  do_dummy8,
};

DRV_HDR *do_get_dftab(char *tpl_name)
{
  /* we only have the one, so this is pretty easy... ;) */
  if (strcmp(tpl_name, trampoline.module) != 0)
    return 0;
  return (DRV_HDR *)&trampoline;
}

int16 do_ETM_exec(char *tpl_name)
{
  /* even easier... ;) */
  return 0;
}
