#ifndef GLOBAL_H
#define GLOBAL_H

#ifndef COMPILER_H
#include <compiler.h>
#endif

#include "drivers.h"
#include "transprt.h"


#ifdef RT_DEBUG
#define DEBUG
#define GS_TRACE	"GLUESTIK_TRACE"
#endif

/* IDs for the semaphores and mailboxes we'll need */
#define DMN_SEMAPHORE		0x53544B58L	/* "STKX" */
#ifdef DEBUG
#define DEBUG_SEMAPHORE		0x53544B44L	/* "STKD" */
#endif /* DEBUG */
#define DMN_MBOX		0x4353444DL	/* "GSDM" */

/* struct for Pmsg() */
typedef struct {
  long userlong1;
  long userlong2;
  short pid;
} PMSG;

extern DRV_HDR* __CDECL do_get_dftab __PROTO((char *));
extern int16 __CDECL do_ETM_exec __PROTO((char *));
 
extern char* __CDECL do_KRmalloc __PROTO((int32));
extern void __CDECL do_KRfree __PROTO((void *));
extern int32 __CDECL do_KRgetfree __PROTO((int16));
extern char* __CDECL do_KRrealloc __PROTO((char *, int32));
extern char* __CDECL do_get_err_text __PROTO((int16));
extern char* __CDECL do_getvstr __PROTO((char *));
extern int16 __CDECL do_carrier_detect __PROTO((void));
extern int16 __CDECL do_TCP_open __PROTO((uint32, int16, int16, uint16));
extern int16 __CDECL do_TCP_close __PROTO((int16, int16));
extern int16 __CDECL do_TCP_send __PROTO((int16, char* , int16));
extern int16 __CDECL do_TCP_wait_state __PROTO((int16, int16, int16));
extern int16 __CDECL do_TCP_ack_wait __PROTO((int16, int16));
extern int16 __CDECL do_UDP_open __PROTO((uint32, int16));
extern int16 __CDECL do_UDP_close __PROTO((int16));
extern int16 __CDECL do_UDP_send __PROTO((int16, char *, int16));
extern int16 __CDECL do_CNkick __PROTO((int16));
extern int16 __CDECL do_CNbyte_count __PROTO((int16));
extern int16 __CDECL do_CNget_char __PROTO((int16));
extern NDB* __CDECL do_CNget_NDB __PROTO((int16));
extern int16 __CDECL do_CNget_block __PROTO((int16, char *, int16));
extern void __CDECL do_housekeep __PROTO((void));
extern int16 __CDECL do_resolve __PROTO((char *, char **, uint32 *, int16));
extern void __CDECL do_ser_disable __PROTO((void));
extern void __CDECL do_ser_enable __PROTO((void));
extern int16 __CDECL do_set_flag __PROTO((int16));
extern void __CDECL do_clear_flag __PROTO((int16));
extern CIB* __CDECL do_CNgetinfo __PROTO((int16));
extern int16 __CDECL do_on_port __PROTO((char *));
extern void __CDECL do_off_port __PROTO((char *));
extern int16 __CDECL do_setvstr __PROTO((char *, char *));
extern int16 __CDECL do_query_port __PROTO((char *));
extern int16 __CDECL do_dummy __PROTO((int));

extern int init_mem __PROTO((void));
extern int init_net __PROTO((void));
extern int init_stubs __PROTO((void));
extern int load_config_file __PROTO((void));
extern void cleanup_config __PROTO((void));
extern void cleanup_mem __PROTO((void));
#ifdef DEBUG
extern void debug(const char *, ...);
#  ifdef RT_DEBUG
extern int debugflag;
#  define debug		(!debugflag)?((void)0):debug
#  endif
#endif

extern CONFIG driver_config;
extern DRV_LIST driver;
extern TPL trampoline;

#endif /* GLOBAL_H */
